#!/usr/bin/perl

# This tool is GPL. See the file COPYING for details.

@timeline=<STDIN>;

for ($i=$#timeline; $i>=0; $i--) {
  $line=$timeline[$i];
  chomp($line);
  my $mac='';
  if ($line=~m/^([a-zA-Z]+)\ ([a-zA-Z]+)\ ([0-9]+)\ ([0-9]+)\ ([0-9\:]+)\ *([0-9]*)\ ([mac\.]{3}) (.?)\/(.?)([^\ ]+)\ ([^\ ]+)\ +([^\ ]+)\ +([0-9]+)\ +([^\ \n]+)/) {
    $mac=$7;
    $ftype=$8;
    $filename=$14;
  }
  if ($line=~m/^\ *([0-9]*)\ ([mac\.]{3}) (.?)\/(.?)([^\ ]+)\ ([^\ ]+)\ +([^\ ]+)\ +([0-9]+)\ +([^\ \n]+)/) {
    $mac=$2;
    $ftype=$3;
    $filename=$9;
  }
  if (!($mac eq '')) {
    $masked_mac{'m'} = 0; $masked_mac{'a'} = 0; $masked_mac{'c'} = 0; 

    if (substr($mac, 0, 1) eq 'm') { 
      $masked_mac{'m'} = 1;
    }
    if (substr($mac, 1, 1) eq 'a') { 
      $masked_mac{'a'} = 1;
    }
    if (substr($mac, 2, 1) eq 'c') { 
      $masked_mac{'c'} = 1;
    }

    if ($mask{$filename}{'m'} == 1) {
      $masked_mac{'m'} = 2;
    }
    if ($mask{$filename}{'a'} == 1) {
      $masked_mac{'a'} = 2;
    }
    if ($mask{$filename}{'c'} == 1) {
      $masked_mac{'c'} = 2;
    }

    $masked_mac='';
    if ($masked_mac{'m'} == 0) {
      $masked_mac = $masked_mac . '.';
    }
    if ($masked_mac{'m'} == 1) {
      $masked_mac = $masked_mac . 'm';
    }
    if ($masked_mac{'m'} == 2) {
      $masked_mac = $masked_mac . '?';
    }
    if ($masked_mac{'a'} == 0) {
      $masked_mac = $masked_mac . '.';
    }
    if ($masked_mac{'a'} == 1) {
      $masked_mac = $masked_mac . 'a';
    }
    if ($masked_mac{'a'} == 2) {
      $masked_mac = $masked_mac . '?';
    }
    if ($masked_mac{'c'} == 0) {
      $masked_mac = $masked_mac . '.';
    }
    if ($masked_mac{'c'} == 1) {
      $masked_mac = $masked_mac . 'c';
    }
    if ($masked_mac{'c'} == 2) {
      $masked_mac = $masked_mac . '?';
    }

    $description = '';
    if ($ftype eq 'd') {
      if (
           (($masked_mac{'m'} == 1) || ($masked_mac{'m'} == 2)) &&
           (($masked_mac{'a'} == 1) || ($masked_mac{'a'} == 2)) &&
           (($masked_mac{'c'} == 1) || ($masked_mac{'c'} == 2))
         ) { $description = $description . '(this directory created) '; }
      if (
           (($masked_mac{'m'} == 1) || ($masked_mac{'m'} == 2)) &&
           (($masked_mac{'a'} == 0) || ($masked_mac{'a'} == 2)) &&
           (($masked_mac{'c'} == 1) || ($masked_mac{'c'} == 2))
         ) { $description = $description . '(subdirectory or file created in this directory) '; }
      if (
           (($masked_mac{'m'} == 0) || ($masked_mac{'m'} == 2)) &&
           (($masked_mac{'a'} == 1) || ($masked_mac{'a'} == 2)) &&
           (($masked_mac{'c'} == 0) || ($masked_mac{'c'} == 2))
         ) { $description = $description . '(directory content listed) '; }
      if (
           (($masked_mac{'m'} == 0) || ($masked_mac{'m'} == 2)) &&
           (($masked_mac{'a'} == 0) || ($masked_mac{'a'} == 2)) &&
           (($masked_mac{'c'} == 1) || ($masked_mac{'c'} == 2))
         ) { $description = $description . '(this directory deleted, chmoded or chowned) '; }
    } else {
      if (
           (($masked_mac{'m'} == 1) || ($masked_mac{'m'} == 2)) &&
           (($masked_mac{'a'} == 1) || ($masked_mac{'a'} == 2)) &&
           (($masked_mac{'c'} == 1) || ($masked_mac{'c'} == 2))
         ) { $description = $description . '(this file created) '; }
      if (
           (($masked_mac{'m'} == 1) || ($masked_mac{'m'} == 2)) &&
           (($masked_mac{'a'} == 0) || ($masked_mac{'a'} == 2)) &&
           (($masked_mac{'c'} == 1) || ($masked_mac{'c'} == 2))
         ) { $description = $description . '(writing to this file) '; }
      if (
           (($masked_mac{'m'} == 0) || ($masked_mac{'m'} == 2)) &&
           (($masked_mac{'a'} == 0) || ($masked_mac{'a'} == 2)) &&
           (($masked_mac{'c'} == 1) || ($masked_mac{'c'} == 2))
         ) { $description = $description . '(this file deleted, chmoded or chowned) '; }
      if (
           (($masked_mac{'m'} == 0) || ($masked_mac{'m'} == 2)) &&
           (($masked_mac{'a'} == 1) || ($masked_mac{'a'} == 2)) &&
           (($masked_mac{'c'} == 0) || ($masked_mac{'c'} == 2))
         ) { $description = $description . '(reading from this file) '; }
    }
    print("$line ($masked_mac) $description\n");

    if (substr($mac, 0, 1) eq 'm') { 
      $mask{$filename}{'m'} = 1;
    }
    if (substr($mac, 1, 1) eq 'a') { 
      $mask{$filename}{'a'} = 1;
    }
    if (substr($mac, 2, 1) eq 'c') { 
      $mask{$filename}{'c'} = 1;
    }
  }
}






